<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<meta http-equiv="content-type" content="text/html; charset=UTF-8" />
<title>TestHttpAsyncHandlerCancellable xref</title>
<link type="text/css" rel="stylesheet" href="../../../../../stylesheet.css" />
</head>
<body>
<div id="overview"><a href="../../../../../../testapidocs/org/apache/http/nio/integration/TestHttpAsyncHandlerCancellable.html">View Javadoc</a></div><pre>

<a class="jxr_linenumber" name="1" href="#1">1</a>   <em class="jxr_comment">/*</em>
<a class="jxr_linenumber" name="2" href="#2">2</a>   <em class="jxr_comment"> * ====================================================================</em>
<a class="jxr_linenumber" name="3" href="#3">3</a>   <em class="jxr_comment"> * Licensed to the Apache Software Foundation (ASF) under one</em>
<a class="jxr_linenumber" name="4" href="#4">4</a>   <em class="jxr_comment"> * or more contributor license agreements.  See the NOTICE file</em>
<a class="jxr_linenumber" name="5" href="#5">5</a>   <em class="jxr_comment"> * distributed with this work for additional information</em>
<a class="jxr_linenumber" name="6" href="#6">6</a>   <em class="jxr_comment"> * regarding copyright ownership.  The ASF licenses this file</em>
<a class="jxr_linenumber" name="7" href="#7">7</a>   <em class="jxr_comment"> * to you under the Apache License, Version 2.0 (the</em>
<a class="jxr_linenumber" name="8" href="#8">8</a>   <em class="jxr_comment"> * "License"); you may not use this file except in compliance</em>
<a class="jxr_linenumber" name="9" href="#9">9</a>   <em class="jxr_comment"> * with the License.  You may obtain a copy of the License at</em>
<a class="jxr_linenumber" name="10" href="#10">10</a>  <em class="jxr_comment"> *</em>
<a class="jxr_linenumber" name="11" href="#11">11</a>  <em class="jxr_comment"> *   <a href="http://www.apache.org/licenses/LICENSE-2.0" target="alexandria_uri">http://www.apache.org/licenses/LICENSE-2.0</a></em>
<a class="jxr_linenumber" name="12" href="#12">12</a>  <em class="jxr_comment"> *</em>
<a class="jxr_linenumber" name="13" href="#13">13</a>  <em class="jxr_comment"> * Unless required by applicable law or agreed to in writing,</em>
<a class="jxr_linenumber" name="14" href="#14">14</a>  <em class="jxr_comment"> * software distributed under the License is distributed on an</em>
<a class="jxr_linenumber" name="15" href="#15">15</a>  <em class="jxr_comment"> * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY</em>
<a class="jxr_linenumber" name="16" href="#16">16</a>  <em class="jxr_comment"> * KIND, either express or implied.  See the License for the</em>
<a class="jxr_linenumber" name="17" href="#17">17</a>  <em class="jxr_comment"> * specific language governing permissions and limitations</em>
<a class="jxr_linenumber" name="18" href="#18">18</a>  <em class="jxr_comment"> * under the License.</em>
<a class="jxr_linenumber" name="19" href="#19">19</a>  <em class="jxr_comment"> * ====================================================================</em>
<a class="jxr_linenumber" name="20" href="#20">20</a>  <em class="jxr_comment"> *</em>
<a class="jxr_linenumber" name="21" href="#21">21</a>  <em class="jxr_comment"> * This software consists of voluntary contributions made by many</em>
<a class="jxr_linenumber" name="22" href="#22">22</a>  <em class="jxr_comment"> * individuals on behalf of the Apache Software Foundation.  For more</em>
<a class="jxr_linenumber" name="23" href="#23">23</a>  <em class="jxr_comment"> * information on the Apache Software Foundation, please see</em>
<a class="jxr_linenumber" name="24" href="#24">24</a>  <em class="jxr_comment"> * &lt;<a href="http://www.apache.org/&gt;." target="alexandria_uri">http://www.apache.org/&gt;.</a></em>
<a class="jxr_linenumber" name="25" href="#25">25</a>  <em class="jxr_comment"> *</em>
<a class="jxr_linenumber" name="26" href="#26">26</a>  <em class="jxr_comment"> */</em>
<a class="jxr_linenumber" name="27" href="#27">27</a>  
<a class="jxr_linenumber" name="28" href="#28">28</a>  <strong class="jxr_keyword">package</strong> org.apache.http.nio.integration;
<a class="jxr_linenumber" name="29" href="#29">29</a>  
<a class="jxr_linenumber" name="30" href="#30">30</a>  <strong class="jxr_keyword">import</strong> java.io.BufferedWriter;
<a class="jxr_linenumber" name="31" href="#31">31</a>  <strong class="jxr_keyword">import</strong> java.io.IOException;
<a class="jxr_linenumber" name="32" href="#32">32</a>  <strong class="jxr_keyword">import</strong> java.io.OutputStream;
<a class="jxr_linenumber" name="33" href="#33">33</a>  <strong class="jxr_keyword">import</strong> java.io.OutputStreamWriter;
<a class="jxr_linenumber" name="34" href="#34">34</a>  <strong class="jxr_keyword">import</strong> java.net.InetSocketAddress;
<a class="jxr_linenumber" name="35" href="#35">35</a>  <strong class="jxr_keyword">import</strong> java.net.Socket;
<a class="jxr_linenumber" name="36" href="#36">36</a>  <strong class="jxr_keyword">import</strong> java.util.concurrent.CountDownLatch;
<a class="jxr_linenumber" name="37" href="#37">37</a>  <strong class="jxr_keyword">import</strong> java.util.concurrent.TimeUnit;
<a class="jxr_linenumber" name="38" href="#38">38</a>  
<a class="jxr_linenumber" name="39" href="#39">39</a>  <strong class="jxr_keyword">import</strong> org.apache.http.HttpCoreNIOTestBase;
<a class="jxr_linenumber" name="40" href="#40">40</a>  <strong class="jxr_keyword">import</strong> org.apache.http.HttpException;
<a class="jxr_linenumber" name="41" href="#41">41</a>  <strong class="jxr_keyword">import</strong> org.apache.http.HttpRequest;
<a class="jxr_linenumber" name="42" href="#42">42</a>  <strong class="jxr_keyword">import</strong> org.apache.http.HttpResponse;
<a class="jxr_linenumber" name="43" href="#43">43</a>  <strong class="jxr_keyword">import</strong> org.apache.http.HttpVersion;
<a class="jxr_linenumber" name="44" href="#44">44</a>  <strong class="jxr_keyword">import</strong> org.apache.http.LoggingClientConnectionFactory;
<a class="jxr_linenumber" name="45" href="#45">45</a>  <strong class="jxr_keyword">import</strong> org.apache.http.LoggingServerConnectionFactory;
<a class="jxr_linenumber" name="46" href="#46">46</a>  <strong class="jxr_keyword">import</strong> org.apache.http.concurrent.Cancellable;
<a class="jxr_linenumber" name="47" href="#47">47</a>  <strong class="jxr_keyword">import</strong> org.apache.http.entity.BasicHttpEntity;
<a class="jxr_linenumber" name="48" href="#48">48</a>  <strong class="jxr_keyword">import</strong> org.apache.http.entity.ContentType;
<a class="jxr_linenumber" name="49" href="#49">49</a>  <strong class="jxr_keyword">import</strong> org.apache.http.impl.DefaultConnectionReuseStrategy;
<a class="jxr_linenumber" name="50" href="#50">50</a>  <strong class="jxr_keyword">import</strong> org.apache.http.impl.DefaultHttpResponseFactory;
<a class="jxr_linenumber" name="51" href="#51">51</a>  <strong class="jxr_keyword">import</strong> org.apache.http.impl.nio.DefaultNHttpClientConnection;
<a class="jxr_linenumber" name="52" href="#52">52</a>  <strong class="jxr_keyword">import</strong> org.apache.http.impl.nio.DefaultNHttpServerConnection;
<a class="jxr_linenumber" name="53" href="#53">53</a>  <strong class="jxr_keyword">import</strong> org.apache.http.message.BasicHttpResponse;
<a class="jxr_linenumber" name="54" href="#54">54</a>  <strong class="jxr_keyword">import</strong> org.apache.http.nio.ContentEncoder;
<a class="jxr_linenumber" name="55" href="#55">55</a>  <strong class="jxr_keyword">import</strong> org.apache.http.nio.IOControl;
<a class="jxr_linenumber" name="56" href="#56">56</a>  <strong class="jxr_keyword">import</strong> org.apache.http.nio.NHttpConnectionFactory;
<a class="jxr_linenumber" name="57" href="#57">57</a>  <strong class="jxr_keyword">import</strong> org.apache.http.nio.protocol.BasicAsyncRequestConsumer;
<a class="jxr_linenumber" name="58" href="#58">58</a>  <strong class="jxr_keyword">import</strong> org.apache.http.nio.protocol.HttpAsyncExchange;
<a class="jxr_linenumber" name="59" href="#59">59</a>  <strong class="jxr_keyword">import</strong> org.apache.http.nio.protocol.HttpAsyncRequestConsumer;
<a class="jxr_linenumber" name="60" href="#60">60</a>  <strong class="jxr_keyword">import</strong> org.apache.http.nio.protocol.HttpAsyncRequestHandler;
<a class="jxr_linenumber" name="61" href="#61">61</a>  <strong class="jxr_keyword">import</strong> org.apache.http.nio.protocol.HttpAsyncRequestHandlerRegistry;
<a class="jxr_linenumber" name="62" href="#62">62</a>  <strong class="jxr_keyword">import</strong> org.apache.http.nio.protocol.HttpAsyncResponseProducer;
<a class="jxr_linenumber" name="63" href="#63">63</a>  <strong class="jxr_keyword">import</strong> org.apache.http.nio.protocol.HttpAsyncService;
<a class="jxr_linenumber" name="64" href="#64">64</a>  <strong class="jxr_keyword">import</strong> org.apache.http.nio.reactor.IOReactorStatus;
<a class="jxr_linenumber" name="65" href="#65">65</a>  <strong class="jxr_keyword">import</strong> org.apache.http.nio.reactor.ListenerEndpoint;
<a class="jxr_linenumber" name="66" href="#66">66</a>  <strong class="jxr_keyword">import</strong> org.apache.http.params.HttpParams;
<a class="jxr_linenumber" name="67" href="#67">67</a>  <strong class="jxr_keyword">import</strong> org.apache.http.protocol.HttpContext;
<a class="jxr_linenumber" name="68" href="#68">68</a>  <strong class="jxr_keyword">import</strong> org.junit.After;
<a class="jxr_linenumber" name="69" href="#69">69</a>  <strong class="jxr_keyword">import</strong> org.junit.Assert;
<a class="jxr_linenumber" name="70" href="#70">70</a>  <strong class="jxr_keyword">import</strong> org.junit.Before;
<a class="jxr_linenumber" name="71" href="#71">71</a>  <strong class="jxr_keyword">import</strong> org.junit.Test;
<a class="jxr_linenumber" name="72" href="#72">72</a>  
<a class="jxr_linenumber" name="73" href="#73">73</a>  <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">class</strong> <a href="../../../../../org/apache/http/nio/integration/TestHttpAsyncHandlerCancellable.html">TestHttpAsyncHandlerCancellable</a> <strong class="jxr_keyword">extends</strong> <a href="../../../../../org/apache/http/HttpCoreNIOTestBase.html">HttpCoreNIOTestBase</a> {
<a class="jxr_linenumber" name="74" href="#74">74</a>  
<a class="jxr_linenumber" name="75" href="#75">75</a>      @Before
<a class="jxr_linenumber" name="76" href="#76">76</a>      <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> setUp() <strong class="jxr_keyword">throws</strong> Exception {
<a class="jxr_linenumber" name="77" href="#77">77</a>          initServer();
<a class="jxr_linenumber" name="78" href="#78">78</a>      }
<a class="jxr_linenumber" name="79" href="#79">79</a>  
<a class="jxr_linenumber" name="80" href="#80">80</a>      @After
<a class="jxr_linenumber" name="81" href="#81">81</a>      <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> tearDown() <strong class="jxr_keyword">throws</strong> Exception {
<a class="jxr_linenumber" name="82" href="#82">82</a>          shutDownServer();
<a class="jxr_linenumber" name="83" href="#83">83</a>      }
<a class="jxr_linenumber" name="84" href="#84">84</a>  
<a class="jxr_linenumber" name="85" href="#85">85</a>      @Override
<a class="jxr_linenumber" name="86" href="#86">86</a>      <strong class="jxr_keyword">protected</strong> NHttpConnectionFactory&lt;DefaultNHttpServerConnection&gt; createServerConnectionFactory(
<a class="jxr_linenumber" name="87" href="#87">87</a>              <strong class="jxr_keyword">final</strong> HttpParams params) <strong class="jxr_keyword">throws</strong> Exception {
<a class="jxr_linenumber" name="88" href="#88">88</a>          <strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">new</strong> <a href="../../../../../org/apache/http/LoggingServerConnectionFactory.html">LoggingServerConnectionFactory</a>(params);
<a class="jxr_linenumber" name="89" href="#89">89</a>      }
<a class="jxr_linenumber" name="90" href="#90">90</a>  
<a class="jxr_linenumber" name="91" href="#91">91</a>      @Override
<a class="jxr_linenumber" name="92" href="#92">92</a>      <strong class="jxr_keyword">protected</strong> NHttpConnectionFactory&lt;DefaultNHttpClientConnection&gt; createClientConnectionFactory(
<a class="jxr_linenumber" name="93" href="#93">93</a>              <strong class="jxr_keyword">final</strong> HttpParams params) <strong class="jxr_keyword">throws</strong> Exception {
<a class="jxr_linenumber" name="94" href="#94">94</a>          <strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">new</strong> <a href="../../../../../org/apache/http/LoggingClientConnectionFactory.html">LoggingClientConnectionFactory</a>(params);
<a class="jxr_linenumber" name="95" href="#95">95</a>      }
<a class="jxr_linenumber" name="96" href="#96">96</a>  
<a class="jxr_linenumber" name="97" href="#97">97</a>      @Test
<a class="jxr_linenumber" name="98" href="#98">98</a>      <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> testResponsePrematureTermination() <strong class="jxr_keyword">throws</strong> Exception {
<a class="jxr_linenumber" name="99" href="#99">99</a>          
<a class="jxr_linenumber" name="100" href="#100">100</a>         <strong class="jxr_keyword">final</strong> CountDownLatch latch = <strong class="jxr_keyword">new</strong> CountDownLatch(1);
<a class="jxr_linenumber" name="101" href="#101">101</a>         <strong class="jxr_keyword">final</strong> HttpAsyncResponseProducer responseProducer = <strong class="jxr_keyword">new</strong> HttpAsyncResponseProducer() {
<a class="jxr_linenumber" name="102" href="#102">102</a>             
<a class="jxr_linenumber" name="103" href="#103">103</a>             <strong class="jxr_keyword">public</strong> HttpResponse generateResponse() {
<a class="jxr_linenumber" name="104" href="#104">104</a>                 HttpResponse response = <strong class="jxr_keyword">new</strong> BasicHttpResponse(HttpVersion.HTTP_1_1, 200, <span class="jxr_string">"OK"</span>);
<a class="jxr_linenumber" name="105" href="#105">105</a>                 BasicHttpEntity entity = <strong class="jxr_keyword">new</strong> BasicHttpEntity();
<a class="jxr_linenumber" name="106" href="#106">106</a>                 entity.setContentType(ContentType.DEFAULT_BINARY.toString());
<a class="jxr_linenumber" name="107" href="#107">107</a>                 entity.setChunked(<strong class="jxr_keyword">true</strong>);
<a class="jxr_linenumber" name="108" href="#108">108</a>                 response.setEntity(entity);
<a class="jxr_linenumber" name="109" href="#109">109</a>                 <strong class="jxr_keyword">return</strong> response;
<a class="jxr_linenumber" name="110" href="#110">110</a>             }
<a class="jxr_linenumber" name="111" href="#111">111</a>             
<a class="jxr_linenumber" name="112" href="#112">112</a>             <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> close() <strong class="jxr_keyword">throws</strong> IOException {
<a class="jxr_linenumber" name="113" href="#113">113</a>                 latch.countDown();
<a class="jxr_linenumber" name="114" href="#114">114</a>             }
<a class="jxr_linenumber" name="115" href="#115">115</a>             
<a class="jxr_linenumber" name="116" href="#116">116</a>             <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> responseCompleted(<strong class="jxr_keyword">final</strong> HttpContext context) {
<a class="jxr_linenumber" name="117" href="#117">117</a>             }
<a class="jxr_linenumber" name="118" href="#118">118</a>             
<a class="jxr_linenumber" name="119" href="#119">119</a>             <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> produceContent(
<a class="jxr_linenumber" name="120" href="#120">120</a>                     <strong class="jxr_keyword">final</strong> ContentEncoder encoder, <strong class="jxr_keyword">final</strong> IOControl ioctrl) <strong class="jxr_keyword">throws</strong> IOException {
<a class="jxr_linenumber" name="121" href="#121">121</a>                 <em class="jxr_comment">// suspend output</em>
<a class="jxr_linenumber" name="122" href="#122">122</a>                 ioctrl.suspendOutput();
<a class="jxr_linenumber" name="123" href="#123">123</a>             }
<a class="jxr_linenumber" name="124" href="#124">124</a>             
<a class="jxr_linenumber" name="125" href="#125">125</a>             <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> failed(<strong class="jxr_keyword">final</strong> Exception ex) {
<a class="jxr_linenumber" name="126" href="#126">126</a>             }
<a class="jxr_linenumber" name="127" href="#127">127</a> 
<a class="jxr_linenumber" name="128" href="#128">128</a>         };
<a class="jxr_linenumber" name="129" href="#129">129</a>         
<a class="jxr_linenumber" name="130" href="#130">130</a>         HttpAsyncRequestHandlerRegistry registry = <strong class="jxr_keyword">new</strong> HttpAsyncRequestHandlerRegistry();
<a class="jxr_linenumber" name="131" href="#131">131</a>         registry.register(<span class="jxr_string">"*"</span>, <strong class="jxr_keyword">new</strong> HttpAsyncRequestHandler&lt;HttpRequest&gt;() {
<a class="jxr_linenumber" name="132" href="#132">132</a> 
<a class="jxr_linenumber" name="133" href="#133">133</a>             <strong class="jxr_keyword">public</strong> HttpAsyncRequestConsumer&lt;HttpRequest&gt; processRequest(
<a class="jxr_linenumber" name="134" href="#134">134</a>                     <strong class="jxr_keyword">final</strong> HttpRequest request,
<a class="jxr_linenumber" name="135" href="#135">135</a>                     <strong class="jxr_keyword">final</strong> HttpContext context) <strong class="jxr_keyword">throws</strong> HttpException, IOException {
<a class="jxr_linenumber" name="136" href="#136">136</a>                 <strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">new</strong> BasicAsyncRequestConsumer();
<a class="jxr_linenumber" name="137" href="#137">137</a>             }
<a class="jxr_linenumber" name="138" href="#138">138</a> 
<a class="jxr_linenumber" name="139" href="#139">139</a>             <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> handle(
<a class="jxr_linenumber" name="140" href="#140">140</a>                     <strong class="jxr_keyword">final</strong> HttpRequest data, 
<a class="jxr_linenumber" name="141" href="#141">141</a>                     <strong class="jxr_keyword">final</strong> HttpAsyncExchange httpExchange, 
<a class="jxr_linenumber" name="142" href="#142">142</a>                     <strong class="jxr_keyword">final</strong> HttpContext context)
<a class="jxr_linenumber" name="143" href="#143">143</a>                     <strong class="jxr_keyword">throws</strong> HttpException, IOException {
<a class="jxr_linenumber" name="144" href="#144">144</a>                 httpExchange.submitResponse(responseProducer);
<a class="jxr_linenumber" name="145" href="#145">145</a>             }
<a class="jxr_linenumber" name="146" href="#146">146</a>             
<a class="jxr_linenumber" name="147" href="#147">147</a>         });
<a class="jxr_linenumber" name="148" href="#148">148</a>         HttpAsyncService serviceHandler = <strong class="jxr_keyword">new</strong> HttpAsyncService(
<a class="jxr_linenumber" name="149" href="#149">149</a>                 <strong class="jxr_keyword">this</strong>.serverHttpProc,
<a class="jxr_linenumber" name="150" href="#150">150</a>                 <strong class="jxr_keyword">new</strong> DefaultConnectionReuseStrategy(),
<a class="jxr_linenumber" name="151" href="#151">151</a>                 <strong class="jxr_keyword">new</strong> DefaultHttpResponseFactory(),
<a class="jxr_linenumber" name="152" href="#152">152</a>                 registry,
<a class="jxr_linenumber" name="153" href="#153">153</a>                 <strong class="jxr_keyword">null</strong>,
<a class="jxr_linenumber" name="154" href="#154">154</a>                 <strong class="jxr_keyword">this</strong>.serverParams);
<a class="jxr_linenumber" name="155" href="#155">155</a>         <strong class="jxr_keyword">this</strong>.server.start(serviceHandler);
<a class="jxr_linenumber" name="156" href="#156">156</a> 
<a class="jxr_linenumber" name="157" href="#157">157</a>         ListenerEndpoint endpoint = <strong class="jxr_keyword">this</strong>.server.getListenerEndpoint();
<a class="jxr_linenumber" name="158" href="#158">158</a>         endpoint.waitFor();
<a class="jxr_linenumber" name="159" href="#159">159</a> 
<a class="jxr_linenumber" name="160" href="#160">160</a>         Assert.assertEquals(<span class="jxr_string">"Test server status"</span>, IOReactorStatus.ACTIVE, <strong class="jxr_keyword">this</strong>.server.getStatus());
<a class="jxr_linenumber" name="161" href="#161">161</a>         InetSocketAddress address = (InetSocketAddress) endpoint.getAddress();
<a class="jxr_linenumber" name="162" href="#162">162</a>         Socket socket = <strong class="jxr_keyword">new</strong> Socket(<span class="jxr_string">"localhost"</span>, address.getPort());
<a class="jxr_linenumber" name="163" href="#163">163</a>         <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="164" href="#164">164</a>             OutputStream outstream = socket.getOutputStream();
<a class="jxr_linenumber" name="165" href="#165">165</a>             BufferedWriter writer = <strong class="jxr_keyword">new</strong> BufferedWriter(<strong class="jxr_keyword">new</strong> OutputStreamWriter(outstream, <span class="jxr_string">"US-ASCII"</span>));
<a class="jxr_linenumber" name="166" href="#166">166</a>             writer.write(<span class="jxr_string">"GET /long HTTP/1.1\r\n"</span>);
<a class="jxr_linenumber" name="167" href="#167">167</a>             writer.write(<span class="jxr_string">"Host: localhost\r\n"</span>);
<a class="jxr_linenumber" name="168" href="#168">168</a>             writer.write(<span class="jxr_string">"\r\n"</span>);
<a class="jxr_linenumber" name="169" href="#169">169</a>             writer.flush();
<a class="jxr_linenumber" name="170" href="#170">170</a>             
<a class="jxr_linenumber" name="171" href="#171">171</a>             Thread.sleep(250);
<a class="jxr_linenumber" name="172" href="#172">172</a>             
<a class="jxr_linenumber" name="173" href="#173">173</a>             writer.close();
<a class="jxr_linenumber" name="174" href="#174">174</a>         } <strong class="jxr_keyword">finally</strong> {
<a class="jxr_linenumber" name="175" href="#175">175</a>             socket.close();
<a class="jxr_linenumber" name="176" href="#176">176</a>         }
<a class="jxr_linenumber" name="177" href="#177">177</a> 
<a class="jxr_linenumber" name="178" href="#178">178</a>         Assert.assertTrue(latch.await(5, TimeUnit.SECONDS));
<a class="jxr_linenumber" name="179" href="#179">179</a>     }
<a class="jxr_linenumber" name="180" href="#180">180</a> 
<a class="jxr_linenumber" name="181" href="#181">181</a>     @Test
<a class="jxr_linenumber" name="182" href="#182">182</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> testRequestCancelled() <strong class="jxr_keyword">throws</strong> Exception {
<a class="jxr_linenumber" name="183" href="#183">183</a>         
<a class="jxr_linenumber" name="184" href="#184">184</a>         <strong class="jxr_keyword">final</strong> CountDownLatch latch = <strong class="jxr_keyword">new</strong> CountDownLatch(1);
<a class="jxr_linenumber" name="185" href="#185">185</a>         <strong class="jxr_keyword">final</strong> Cancellable cancellable = <strong class="jxr_keyword">new</strong> Cancellable() {
<a class="jxr_linenumber" name="186" href="#186">186</a>             
<a class="jxr_linenumber" name="187" href="#187">187</a>             <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">boolean</strong> cancel() {
<a class="jxr_linenumber" name="188" href="#188">188</a>                 latch.countDown();
<a class="jxr_linenumber" name="189" href="#189">189</a>                 <strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">true</strong>;
<a class="jxr_linenumber" name="190" href="#190">190</a>             }
<a class="jxr_linenumber" name="191" href="#191">191</a>         };
<a class="jxr_linenumber" name="192" href="#192">192</a>         
<a class="jxr_linenumber" name="193" href="#193">193</a>         HttpAsyncRequestHandlerRegistry registry = <strong class="jxr_keyword">new</strong> HttpAsyncRequestHandlerRegistry();
<a class="jxr_linenumber" name="194" href="#194">194</a>         registry.register(<span class="jxr_string">"*"</span>, <strong class="jxr_keyword">new</strong> HttpAsyncRequestHandler&lt;HttpRequest&gt;() {
<a class="jxr_linenumber" name="195" href="#195">195</a> 
<a class="jxr_linenumber" name="196" href="#196">196</a>             <strong class="jxr_keyword">public</strong> HttpAsyncRequestConsumer&lt;HttpRequest&gt; processRequest(
<a class="jxr_linenumber" name="197" href="#197">197</a>                     <strong class="jxr_keyword">final</strong> HttpRequest request,
<a class="jxr_linenumber" name="198" href="#198">198</a>                     <strong class="jxr_keyword">final</strong> HttpContext context) <strong class="jxr_keyword">throws</strong> HttpException, IOException {
<a class="jxr_linenumber" name="199" href="#199">199</a>                 <strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">new</strong> BasicAsyncRequestConsumer();
<a class="jxr_linenumber" name="200" href="#200">200</a>             }
<a class="jxr_linenumber" name="201" href="#201">201</a> 
<a class="jxr_linenumber" name="202" href="#202">202</a>             <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> handle(
<a class="jxr_linenumber" name="203" href="#203">203</a>                     <strong class="jxr_keyword">final</strong> HttpRequest data, 
<a class="jxr_linenumber" name="204" href="#204">204</a>                     <strong class="jxr_keyword">final</strong> HttpAsyncExchange httpExchange, 
<a class="jxr_linenumber" name="205" href="#205">205</a>                     <strong class="jxr_keyword">final</strong> HttpContext context)
<a class="jxr_linenumber" name="206" href="#206">206</a>                     <strong class="jxr_keyword">throws</strong> HttpException, IOException {
<a class="jxr_linenumber" name="207" href="#207">207</a>                 httpExchange.setCallback(cancellable);
<a class="jxr_linenumber" name="208" href="#208">208</a>                 <em class="jxr_comment">// do not submit a response;</em>
<a class="jxr_linenumber" name="209" href="#209">209</a>             }
<a class="jxr_linenumber" name="210" href="#210">210</a>             
<a class="jxr_linenumber" name="211" href="#211">211</a>         });
<a class="jxr_linenumber" name="212" href="#212">212</a>         HttpAsyncService serviceHandler = <strong class="jxr_keyword">new</strong> HttpAsyncService(
<a class="jxr_linenumber" name="213" href="#213">213</a>                 <strong class="jxr_keyword">this</strong>.serverHttpProc,
<a class="jxr_linenumber" name="214" href="#214">214</a>                 <strong class="jxr_keyword">new</strong> DefaultConnectionReuseStrategy(),
<a class="jxr_linenumber" name="215" href="#215">215</a>                 <strong class="jxr_keyword">new</strong> DefaultHttpResponseFactory(),
<a class="jxr_linenumber" name="216" href="#216">216</a>                 registry,
<a class="jxr_linenumber" name="217" href="#217">217</a>                 <strong class="jxr_keyword">null</strong>,
<a class="jxr_linenumber" name="218" href="#218">218</a>                 <strong class="jxr_keyword">this</strong>.serverParams);
<a class="jxr_linenumber" name="219" href="#219">219</a>         <strong class="jxr_keyword">this</strong>.server.start(serviceHandler);
<a class="jxr_linenumber" name="220" href="#220">220</a> 
<a class="jxr_linenumber" name="221" href="#221">221</a>         ListenerEndpoint endpoint = <strong class="jxr_keyword">this</strong>.server.getListenerEndpoint();
<a class="jxr_linenumber" name="222" href="#222">222</a>         endpoint.waitFor();
<a class="jxr_linenumber" name="223" href="#223">223</a> 
<a class="jxr_linenumber" name="224" href="#224">224</a>         Assert.assertEquals(<span class="jxr_string">"Test server status"</span>, IOReactorStatus.ACTIVE, <strong class="jxr_keyword">this</strong>.server.getStatus());
<a class="jxr_linenumber" name="225" href="#225">225</a>         InetSocketAddress address = (InetSocketAddress) endpoint.getAddress();
<a class="jxr_linenumber" name="226" href="#226">226</a>         Socket socket = <strong class="jxr_keyword">new</strong> Socket(<span class="jxr_string">"localhost"</span>, address.getPort());
<a class="jxr_linenumber" name="227" href="#227">227</a>         <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="228" href="#228">228</a>             OutputStream outstream = socket.getOutputStream();
<a class="jxr_linenumber" name="229" href="#229">229</a>             BufferedWriter writer = <strong class="jxr_keyword">new</strong> BufferedWriter(<strong class="jxr_keyword">new</strong> OutputStreamWriter(outstream, <span class="jxr_string">"US-ASCII"</span>));
<a class="jxr_linenumber" name="230" href="#230">230</a>             writer.write(<span class="jxr_string">"GET /long HTTP/1.1\r\n"</span>);
<a class="jxr_linenumber" name="231" href="#231">231</a>             writer.write(<span class="jxr_string">"Host: localhost\r\n"</span>);
<a class="jxr_linenumber" name="232" href="#232">232</a>             writer.write(<span class="jxr_string">"\r\n"</span>);
<a class="jxr_linenumber" name="233" href="#233">233</a>             writer.flush();
<a class="jxr_linenumber" name="234" href="#234">234</a>             
<a class="jxr_linenumber" name="235" href="#235">235</a>             Thread.sleep(250);
<a class="jxr_linenumber" name="236" href="#236">236</a>             
<a class="jxr_linenumber" name="237" href="#237">237</a>             writer.close();
<a class="jxr_linenumber" name="238" href="#238">238</a>         } <strong class="jxr_keyword">finally</strong> {
<a class="jxr_linenumber" name="239" href="#239">239</a>             socket.close();
<a class="jxr_linenumber" name="240" href="#240">240</a>         }
<a class="jxr_linenumber" name="241" href="#241">241</a> 
<a class="jxr_linenumber" name="242" href="#242">242</a>         Assert.assertTrue(latch.await(5, TimeUnit.SECONDS));
<a class="jxr_linenumber" name="243" href="#243">243</a>     }
<a class="jxr_linenumber" name="244" href="#244">244</a> 
<a class="jxr_linenumber" name="245" href="#245">245</a> }
</pre>
<hr/><div id="footer">This page was automatically generated by <a href="http://maven.apache.org/">Maven</a></div></body>
</html>

